#ifdef __cplusplus
extern "C" {
#endif
#define NoError 						0
#define ID_ERROR					-1
#define SLOT_ERROR					-2
#define CHANNEL_ERROR				-3
#define GAIN_ERROR					-4
#define FIFO_EMPTY      				-5
#define FIFO_LATCHED    				-6
#define FIFO_OVERFLOW   			-7
#define TX_NOTREADY    				-8
#define FIFO_ISR_ERROR 				-9
#define REG_SLOT_ISR_ERROR 		-100
#define MAX_FIFO					4096

#define Average_Sample_Rate_DIFF_Error	-10
#define Average_Sample_Rate_SING_Error	-11
#define Average_Level_Error				-12

short i8014W_Init(int slot);
short i8014W_GetLibVersion(void);
void i8014W_GetLibDate(char libDate[]);
short i8014W_GetFirmwareVer_L1(int slot);
short i8014W_GetFirmwareVer_L2(int slot);
short i8014W_GetSingleEndJumper(int slot);
void i8014W_ReadGainOffset(int slot,short gain,unsigned short* gainValue, short* offsetValue);
// for I-8014CW only
void i8014W_Read_mA_GainOffset(int slot,short ch ,unsigned short* GainValue, short* offsetValue);
void i8014W_Calibrate_CH_mA_Hex(int slot, int ch ,short dataFromFIFO, short* calibratedAI);
void i8014W_Calibrate_CH_mA(int slot, int ch ,short dataFromFIFO, float* calibratedAI);
// for I-8014
void i8014W_CalibrateDataHex(int slot, short iGain,short dataFromFIFO, short* calibratedAI);
void i8014W_CalibrateData(int slot, short iGain,short dataFromFIFO, float* calibratedAI);
short i8014W_ReadAIHex(int slot,short ch,short gain, short* hVal);
short i8014W_ReadAI(int slot,short ch,short gain, float* fVal);
void i8014W_ClearFIFO(int slot);
void  i8014W_UnLockFIFO(int slot);
void i8014W_ConfigMagicScan(int slot,short chArr[],short gainArr[],short scanChCount,float sampleRate,short scanMode,short triggerSource,short triggerState, float* realSampleRate);
short i8014W_StartMagicScan(int slot);
short i8014W_StopMagicScan(int slot);
short i8014W_Set_FIFO_Limit(int slot, short limit);
short i8014W_ReadFIFO(int slot, short hexData[], short readCount,short* dataCountFromFIFO);// <=== get data from FIFO ,long* dataCnt
short i8014W_ReadFIFO_BlockMode(int slot, short dataBuf[], long readCount ,long* dataCountFromFIFO);
short i8014W_ReadFIFO_InISR(int slot, short hexData[], short triggerLevel,short* dataCountFromFIFO);
// API for magic scan isr function
#ifdef WIN32
short i8014W_InstallMagicScanISR(int slot,void(__stdcall *isr)(int slot),short triggerLevel); //<=== give a callback function for interrupt
#else
short i8014W_InstallMagicScanISR(int slot,void(*isr)(int slot),short triggerLevel); //<=== give a callback function for interrupt
#endif
short i8014W_UnInstallMagicScanISR(int slot); //<=== give a callback function for interrupt 
void i8014W_ClearInt(int slot);
#ifdef __cplusplus
}
#endif